
/* BLANKING.H  written by Wayne Pearson
   This Small C header file uses the ROM BIOS to blank areas on the CRT.
   blank() removes any characters from a CRT display block and allows
           new characters to be written to the display block area.
   nochars() removes any characters from a CRT display block area and
             prohibits display of any new characters in the block area.

   Note: nochars() behaves like blank() in monochrome video mode.
         nochars() will not cause a run-time error in monochrome mode.
         The character prohibition works only in the color modes.

   Valid function calls:
                         blank(5,10,15,20);  blanks a CRT block area
                                             from row 5 column 10 to
                                             row 15 column 20.

                         nochars(5,10,15,20); blanks the CRT block area
                                              and does not allow any new
                                              characters to be visible.
*/

blank(bl_y1,bl_x1,bl_y2,bl_x2)
                                  int bl_y1, bl_x1, bl_y2, bl_x2;
                               {
                                  int10(6,0,7,0,bl_y1,bl_x1,bl_y2,bl_x2);
                               }

nochars(nl_y1,nl_x1,nl_y2,nl_x2)
                                   int nl_y1, nl_x1, nl_y2, nl_x2;
                                {
                                   int10(6,0,0,0,nl_y1,nl_x1,nl_y2,nl_x2);
                                }


